import java.util.*;

public class Ball extends PhysicsElement {
   private static int id=0;  // Ball identification number
   private final double mass;
   private double pos_t;     // current position at time t
   private double pos_tPlusDelta;  // next position in delta time in future
   private double speed_t;   // speed at time t
   private double speed_tPlusDelta;   // speed in delta time in future
   private double acel_t;
   private double acel_tPlusDelta;
   
   private Ball(){   // nobody can create an object without state
     this(1.0,0,0,0);
   }
   public Ball(double mass, double position, double speed){
      super(id++);
      this.mass = mass;
      pos_t = position;
      speed_t = speed;
      acel_t = 0;
   }
   public Ball(double mass, double position, double speed, double aceleration){
      super(id++);
      this.mass = mass;
      pos_t = position;
      speed_t = speed;
      acel_t = aceleration;
   }
   public double getPosition() {
     return pos_t;
   }
   public void computeNextState(double delta_t) {
      // to be coded by you
      pos_tPlusDelta = pos_t + speed_t*delta_t;
   }
   public void updateState(){
      // to be coded by you
      pos_t = pos_tPlusDelta;
   }
   public String getDescription() {
   // to be coded by you
      String ss = "Ball_"+this.getId() +" x";
      return ss;
   }
   public String getState() {
   // to be coded by you
      String ss = pos_t+" ";
      return ss;
   }
}