import java.io.*;
import java.util.Locale;
import java.util.Scanner;

public class PhysicsLab {
   public static void main(String[] args) {
     double deltaTime;
     double endTime;
     double samplingTime;
     
     if (args.length != 3) {
         Scanner keyboard   = new Scanner(System.in);
         keyboard.useLocale( new Locale("EN"));
         System.err.println("Introduzca delta tiempo:");
         deltaTime         = keyboard.nextDouble();
         System.err.println("Introduzca duracion en segundos:");
         endTime           = keyboard.nextDouble();  
         System.err.println("Introduzca tiempo de muestreo:");
         samplingTime      = keyboard.nextDouble();
      }
      else{
         deltaTime      = Double.parseDouble(args[0]);      // [s]
         endTime        = Double.parseDouble(args[1]);      // [s]
         samplingTime   = Double.parseDouble(args[2]);      // [s]
      }
      MyWorld world = new MyWorld(System.out);
      
      Oscillator osc = new Oscillator(0.0, 0.25, 0.2);
      double mass = 1.0;      // [kg] 
      double position = 1.5;  // [m] 
      Ball b = new Ball(mass, position, 0);
      world.addElement(osc);
      world.addElement(b);
      Spring s = new Spring (1.0,1.0);
      s.attachEnd(osc);
      s.attachEnd(b);
      world.addElement(s);
      world.simulate(deltaTime, endTime, samplingTime); // delta time[s], total simulation time [s].
   }
}