import java.util.*;

public class Ball extends PhysicsElement implements Attachable{
   private static int id=0;  // Ball identification number
   private final double mass;
   private double pos_t;     // current position at time t
   private double pos_tPlusDelta;  // next position in delta time in future
   private double speed_t;   // speed at time t
   private double speed_tPlusDelta;   // speed in delta time in future
   private double a_t;    // acceleration at time t
   private double a_tMinusDelta; 
   private Spring spring=null;
   
   private Ball(){   // nobody can create a ball without state
     this(1.0,0,0);
   }
   public Ball(double mass, double position, double speed){
      super(id++);
      this.mass = mass;
      pos_t = position;
      speed_t = speed;
   }
   public double getPosition() {
     return pos_t;
   }
   public void attach(Spring s){
// to be coded
    spring = s;
   }
   private double getNetForce(){
     return spring.getForce(this);
   }

   public void computeNextState(double delta_t) {
// to be coded
      double f = this.getNetForce();
      a_t = f/mass;
      speed_tPlusDelta = speed_t + (3*a_t - a_tMinusDelta)*delta_t*0.5;
      pos_tPlusDelta = pos_t + speed_t*delta_t +(4*a_t - a_tMinusDelta)*delta_t*delta_t/6;
   }
   
   public void updateState(){
// to be coded
      pos_t = pos_tPlusDelta;
      speed_t = speed_tPlusDelta;
      a_tMinusDelta = a_t;
   }
   public String getDescription() {
   // to be coded by you
      String ss = "Ball_"+this.getId() +" x";
      return ss;
   }
  public String getState() {
   // to be coded by you
      String ss = Double.toString(pos_t);
      return ss;
  }
}
