import java.io.*;
import java.util.Locale;
import java.util.Scanner;

public class PhysicsLab {
   public static void main(String[] args) {
     double deltaTime;
     double endTime;
     double samplingTime;
     
     if (args.length != 3) {
         Scanner keyboard   = new Scanner(System.in);
         keyboard.useLocale( new Locale("EN"));
         System.err.println("Introduzca delta tiempo:");
         deltaTime         = keyboard.nextDouble();
         System.err.println("Introduzca duracion en segundos:");
         endTime           = keyboard.nextDouble();  
         System.err.println("Introduzca tiempo de muestreo:");
         samplingTime      = keyboard.nextDouble();
      }
      else{
         deltaTime      = Double.parseDouble(args[0]);      // [s]
         endTime        = Double.parseDouble(args[1]);      // [s]
         samplingTime   = Double.parseDouble(args[2]);      // [s]
      }
      MyWorld world = new MyWorld(System.out);
      
      Oscillator osc = new Oscillator(3.0, 0.8, 0.2);
      Ball b = new Ball(1.0, 0, 0);
      Ball b1 = new Ball(2.0, 5, 0);
      world.addElement(osc);
      world.addElement(b);
      world.addElement(b1);
      Spring s = new Spring (1.0,1.0);
      s.attachEnd(osc);
      s.attachEnd(b);
      world.addElement(s);
      Spring s1 = new Spring (2.0,2.0);
      s1.attachEnd(osc);
      s1.attachEnd(b1);
      world.addElement(s1);
      world.simulate(deltaTime, endTime, samplingTime); // delta time[s], total simulation time [s].
   }
}